﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace SolSoft.ObjectOrientedGuiStartup.Wpf
{
	/// <summary>
	/// Second refactoring: separate message loop
	/// </summary>
	class Program2
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main()
		{
			Program2 p = new Program2();
			p.Start();
		}

		private readonly AppNoStartupUri m_app;
		private Program2()
		{
			m_app = new AppNoStartupUri
			{
				ShutdownMode = ShutdownMode.OnExplicitShutdown
			};
			m_app.InitializeComponent();
		}

		public void Start()
		{
			MainViewModel viewModel = new MainViewModel();
			viewModel.CloseRequested += viewModel_CloseRequested;
			viewModel.Initialize();

			MainWindow mainForm = new MainWindow();
			mainForm.Closed += (sender, e) =>
			{
				viewModel.RequestClose();
			};
			
			mainForm.DataContext = viewModel;
			mainForm.Show();
			m_app.Run();
		}

		void viewModel_CloseRequested(object sender, EventArgs e)
		{
			m_app.Shutdown();
		}
	}
}
